package com.gic.finance.constant;
/**
 * 开票户使用状态
 * @ClassName: InitiatorTypeEnum 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/13 10:56 AM 
 */
public enum InvoiceUseStatusEnum {
    ENABLE(1, "启用"),
    DISABLE(2, "停用"),
    DELETE(3, "删除");

    private int code;
    private String message;

    private InvoiceUseStatusEnum(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public static String getMessageByCode(Integer code) {
        if (code == null) {
            return "--";
        }
        for (InvoiceUseStatusEnum typeEnum : values()) {
            if (code.intValue() == typeEnum.getCode()) {
                return typeEnum.getMessage();
            }
        }
        return "未知";
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
