package com.gic.finance.constant;
/**
 * 提现审核状态
 * @ClassName: InvoiceStatusEnum 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/14 2:30 PM 
 */
public enum WithdrawalStatusEnum {
    TO_BE_EXAMINE(1, "待审核"),
    PASS(2, "审核通过"),
    COMPLETE(3, "已完成"),
    REJECT(5, "已驳回"),
    CANCEL(4, "已取消");

    private int code;
    private String message;

    private WithdrawalStatusEnum(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public static String getMessageByCode(Integer code) {
        if (code == null) {
            return "--";
        }
        for (WithdrawalStatusEnum typeEnum : values()) {
            if (code.intValue() == typeEnum.getCode()) {
                return typeEnum.getMessage();
            }
        }
        return "未知";
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
