package com.gic.finance.service.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.finance.dao.mapper.TabPayAccountMapper;
import com.gic.finance.dto.PayAccountDTO;
import com.gic.finance.entity.TabPayAccount;
import com.gic.finance.service.PayAccountService;

@Service("payAccountService")
public class PayAccountServiceImpl implements PayAccountService {
    @Autowired
    private TabPayAccountMapper tabPayAccountMapper;

    @Override
    public int save(PayAccountDTO dto) {
        return tabPayAccountMapper.insert(EntityUtil.changeEntityNew(TabPayAccount.class, dto));
    }

    @Override
    public int update(PayAccountDTO dto) {
        dto.setUpdateTime(new Date());
        return tabPayAccountMapper.updateByPrimaryKeySelective(EntityUtil.changeEntityNew(TabPayAccount.class, dto));
    }

    @Override
    public List<PayAccountDTO> listPayAccount() {
        return EntityUtil.changeEntityListNew(PayAccountDTO.class, tabPayAccountMapper.listPayAccount());
    }

    @Override
    public TabPayAccount getById(Integer id) {
        return tabPayAccountMapper.selectByPrimaryKey(id);
    }

    @Override
    public void setSort(TabPayAccount record, Integer sortValue) {
        List<TabPayAccount> list = tabPayAccountMapper.listPayAccount();
        Integer fromSortValue = record.getSort();
        if (fromSortValue > sortValue) {
            //向上拖拽
            for (int i = 0, length = list.size(); i < length; i++) {
                TabPayAccount temp = list.get(i);
                //如果大于sortValue，都需要降低排序值,往后推
                boolean isNeedDown = temp.getSort() >= sortValue && temp.getSort() < fromSortValue;
                if (isNeedDown) {
                    updateSort(list.get(i + 1).getSort(), temp.getPayAccountId());
                }
            }
        } else if (fromSortValue < sortValue) {
            //向下拖拽
            for (int i = 0, length = list.size(); i < length; i++) {
                TabPayAccount temp = list.get(i);
                boolean isNeedUp = temp.getSort() <= sortValue && temp.getSort() > fromSortValue;
                if (isNeedUp) {
                    updateSort(list.get(i - 1).getSort(), temp.getPayAccountId());
                }
            }
        }
        updateSort(sortValue, record.getPayAccountId());
    }

    @Override
    public int getTheMaxSort() {
        return tabPayAccountMapper.getMaxSort();
    }

    @Override
    public int getMinSort() {
        return tabPayAccountMapper.getMinSort();
    }

    @Override
    public TabPayAccount getPreOfSort(Integer sort) {
        return null;
    }

    @Override
    public TabPayAccount getNextOfSort(Integer sort) {
        return null;
    }

    private void updateSort(Integer sort, Integer id) {
        TabPayAccount record = new TabPayAccount();
        record.setPayAccountId(id);
        record.setSort(sort);
        tabPayAccountMapper.updateByPrimaryKeySelective(record);
    }
}
